<?php

/******************************** copyright ************************************
/*
/*	All upphovsrtt tillfaller adversus art, web & media samt 
/*	Victor Spng Arthursson.
/*
/*	Ingen kod fr anvndas i annat sammanhang n vad som skriftligen verrens-
/*	kommet med ovan nmnda, och inte heller modifieras p ngot stt. I vrigt
/*	gller svensk upphovsrttslagstiftning.
/*
/*	Fr ytterligare information och kontakt:
/*	web:	http://www.adversus.se
/*	mail:	info@adversus.se
/*	tel: +46 (0)733 20 40 02
/*
/*
/*						*** copyright - english version ***
/*
/*	All copyright belongs to adversus art, web & media and
/*	Victor Spng Arthursson.
/*
/*	No code may be used in other circumstances than what has been writtenly agreed
/*	upon with the copyright holder according to above, and it may not be modified
/*	in any what so ever way. For other issues, the swedish copyright laws applies.
/*
/*	More information and contact:
/*	web:	http://www.adversus.se
/*	mail:	info@adversus.se
/*	tel: +46 (0)733 20 40 02
/*
/******************************************************************************/


// *** Sprkvariabler ***
$commentHandler_txt["SE"][0] = "Stigen till xml-filen r felaktigt angiven. Kommentardata kan inte lsas in.";
$commentHandler_txt["UK"][0] = "The path to the xml-file is not correct. The comment data cannot be read.";
$commentHandler_txt["SE"][2] = "Kunde inte skapa xml-filen. Kontrollera att inte foldern dr instllningar sparas r skrivskyddad.";
$commentHandler_txt["UK"][2] = "Couldn't create the xml-file. Please confirm that the folder where the preferences are saved is not write protected.";
// ### Sprkvariabler ###


class commentHandler {

	protected $xml;										// klassens DOM-referens
	private $xmlIsLoaded = false; 						// boolean som stts till true nr en xml laddas
	protected $prefs;									// instllningarna utifrn
	public $lasterror;									// innehller senaste fel
	protected $xpath;									// klassens XPath-referens
	private $xmlpath;									// innehller stigen till xml-filen i frga
	private $origpath;									// detta r stigen till objektet (foldern/bilden i frga)
	protected $commentDataTypes = array("name","desc");	// godknda element
	private $text;										// hller sprkvariablerna.

	// konstruktor. r path satt krs en loadFile automatiskt
	function __construct($path = NULL) {
		
		// hmta in preferences
		$this->prefs = $GLOBALS["prefs"];
		
		// hmta sprkvariablerna
		$this->text = $GLOBALS["commentHandler_txt"];
		$this->text = $this->text[$this->prefs["activelang"]]; 

		// skapa ett xml-dokument, tomt
		$this->xml = new DOMDocument('1.0', 'utf-8');

		// ignorera whitespace
		$this->xml->preserveWhiteSpace = false;

		// formatera output
		$this->xml->formatOutput = true;
		
		if(!is_null($path))
			return $this->loadData($path);
		else
			return true;
		}

	// den hr metoden laddar xml-fil med commentdata
	public function loadData($path) {
		// existerar filen s ladda den och associera den med xpath. Annars returnera false
		if(file_exists($path)){
			
			$this->xml->load($path);
			$this->xmlpath = $path;
			$this->xpath = new DOMXpath($this->xml);
			$this->xmlIsLoaded = true;
			
			return true;
		}
		elseif(!is_null($path)) {
			// frsk skapa den
			$handle = fopen($path, 'w+');
			if(!$handle) {
				// stt felmeddelande
				$this->lasterror = $this->text[2];
				// avbryt
				return false;
			}
			else 
				// stng filen
				fclose($handle);
			// spara stigen till filen
			$this->xmlpath = $path;
			// skapa root-elementet
			$picturedata = $this->xml->createElement("picturedata");
			// lgg till det
			$this->xml->appendChild($picturedata);
			// spara filen - detta eftersom det inte r skert det kommer gras senare och grs det inte har vi inte en valid fil
			$this->saveCommentFile();
			// so far so good - ladda xpath-objektet och stt flagga fr att allt r laddat
			$this->xpath = new DOMXpath($this->xml);
			$this->xmlIsLoaded = true;
			// avsluta och returnera true
			return true;
		}
	}
	
	// den hr metoden laddar xml-fil med commentdata
	public function saveCommentFile($path = NULL) {
		if(is_null($path) or !is_dir($path))
			$path = $this->xmlpath;
		return $this->xml->save($path);
	}
	
	// den hr metoden returnerar vald commentData fr ett objekt som finns i xml-filen. r inte typ satt returneras samtliga
	protected function getCommentData($xPathQuery, $type) {

		// hmta endast data ifall data r laddad
		if($this->xmlIsLoaded) {
		
			// avgr vad fr slags data som ska returneras
			
			// returnera ev samtliga
			if(is_null($type)) {
				// skapa en vektor fr att hlla datan
				$returnData = array();
				
				foreach ($this->commentDataTypes as $validType){
					$returnData[$validType] = $this->getCommentData($xPathQuery, $validType);
				}
				
				return $returnData;
			}
			elseif(in_array($type, $this->commentDataTypes)) {
		
				// sen kr vi frgan med vrt xpath-objekt
				$result = $this->xpath->query($xPathQuery . "/$type");
	
				// fick vi ngot resultat s returnera det
				if($result->length>0)	
					// har allt gtt enligt planerna finns datan i frsta objektet
					return utf8_decode($result->item(0)->nodeValue);
				// annars returnera false
				else
					return false;
			}
			else
				return false;
		}
		// annars r ingen data laddad - returnera false och stt felbesked
		else {
			$this->lasterror = $this->text[1];
			return false;
		}
	}
	
	function __destruct() {
		// why can't I call $this->saveCommentFile from here?
		unset($this->xml, $this->xpath, $this->xmlpath, $this->origpath,  $this->commentDataTypes, $this->lasterror, $this->prefs);
	}
}
?>