<?php

// *** Sprkvariabler ***

$imageProcessor_txt["SE"][1]	= "Bilden existerar inte. Kontrollera att inte ngon felaktig stig har angetts i instllningarna.";
$imageProcessor_txt["UK"][1]	= "The picture doesn't exist. Please check that no faulty path has been submitted in the preferences.";
$imageProcessor_txt["SE"][2]	= "Kan inte berkna bildens storlek och/eller typ. Antagligen r bilden korrupt, alternativt av en typ som inte galleriet stdjer. Fr nrvarande stds gif, png samt jpg.";
$imageProcessor_txt["UK"][2]	= "Can not calculate the size or/and the type of the picture. Either the picture is corrupt, or is of a type which the gallery doesn't support. The supported types are, for the moment, gif, png and jpg.";
$imageProcessor_txt["SE"][3]	= "Kunde inte lsa in bilden.";
$imageProcessor_txt["UK"][3]	= "Couldn't read the picture.";
$imageProcessor_txt["SE"][5]	= "Det saknas tyvrr std fr gif i den hr versionen av GD.";
$imageProcessor_txt["UK"][5]	= "Unfortunately this version of GD lacks the support of gif.";
$imageProcessor_txt["SE"][6]	= "Kan inte initialisera en ny true-color-bild.";
$imageProcessor_txt["UK"][6]	= "Couldn't initialize a new true color picture.";
$imageProcessor_txt["SE"][7]	= "Kunde inte storleksndra bilden.";
$imageProcessor_txt["UK"][7]	= "Couldn't change the size of the picture.";
$imageProcessor_txt["SE"][8]	= "Tyvrr stds inte denna bildtyp av Adversus Easygallery.";
$imageProcessor_txt["UK"][8]	= "Unfortunately isn't this type of picture supported by Adversus Easygallery.";
$imageProcessor_txt["SE"][9]	= "Kunde inte returnera en";
$imageProcessor_txt["UK"][9]	= "Couldn't return a";
$imageProcessor_txt["SE"][10]	= "Kunde inte spara en";
$imageProcessor_txt["UK"][10]	= "Couldn't save a";
$imageProcessor_txt["SE"][11]	= "Anledningen kan vara att ingen originalbild r laddad.";
$imageProcessor_txt["UK"][11]	= "Possible cause can be that no original picture is loaded.";

// ### Sprkvariabler ###

class imageProcessor {

	// klassens interna variabler 
	protected $prefs;	// instllningarna
	public $lastError;	// Innehller senaste fel i klartext
	private $imagePath;	// stig till bilden. Absolut.
	private $im;		// handle fr bilden
	private $quality;	// high / low
	public $src_width, $src_height, $src_type;	// variabler som hller originaldata om bilden
	private $ny_width, $ny_height, $ny_type;	// variabler som hller ny data om bilden
	private $text;		// variabel som innehler sprkvariabler p valt sprk
//	private $isResized;	// (boolean) Stts till false nr funktionen laddas. Stts till true nr bilden r recalculated

	// (klar) krs vid initiering av objekt. $path stts ev
	function __construct($path = NULL) {

		// stt instllningarna - hmta dem frn contexten denna klass befinner sig i, d v s filen som inkluderar denna fil mste ha $prefs def i sig
		$this->prefs = $GLOBALS["prefs"];
		
		// hmta in aktivt sprk
		$this->activelang = $this->prefs["activelang"];

		// hmta in sprkvariabler
		$this->text = $GLOBALS["imageProcessor_txt"];
		$this->text = $this->text[$this->activelang];

		// stt ev bild-path frn starten
		if(!is_null($path)) 
			$this->loadImage($path);
	}

	// (klar) laddar in en bild till variabeln $im
	public function loadImage($path, $quality = "low") {
	
		// om det gick att stta stigen till bilden s gr det tminstone att lsa bilden
		if($this->setPathToImage($path)) {
		
			// gr det att hmta ut all data om bilden?
			if ($this->setImageData()) {
				// stt kvalitet - varfr??? OBS OBS OBS
				$this->quality = ($quality == "high"?"high":"low");
				// eftersom det gtt bra s lngt s returnerar vi true
				return true;
			}
		}

		// stigen existerar inte
		return false;			
		
	}
	
	// (klar) stter stig till bild
	private function setPathToImage($path) {

		// kontrollera att verkligen pathen existerar
		if(file_exists($this->prefs["base_path"] . "/" . $this->prefs["pic_path"] . "/" . $path)) {
			// om s stt variabel
			$this->imagePath = $this->prefs["base_path"] . "/" . $this->prefs["pic_path"] . "/" . $path;
			return true;
		}

		// om inte stt felvariabel
		else {
			$this->lastError = $this->text[1];
			return false;
		}
	}
	
	// (klar) hmtar bilddata (strl, typ) //////och rknar ut nya storlekar (calculateImageData) baserat p innehllet i instllningarna. Returneras inte utan sparas
	private function setImageData() {
	
		// hmta dimensionerna och typ
		list($this->src_width, $this->src_height, $src_type) = getimagesize($this->imagePath);
		
		if($src_type == 1) { // gif
			// stt variabel som kommer ihg filtyp
			$this->src_type = "gif";
			// finns gif-support i den hr versionen?
			if(function_exists("ImageCreateFromGIF")) {
				// ls in bilddata till variabeln $im
			   if(!$this->im = @ImageCreateFromGIF ($this->imagePath)) {
					// stt felbesked
					$this->lastError = $this->text[3];
					// returnera false
					return false;
				}
			}
			else { // ingen gif-support - avbryt
				$this->lastError = $this->text[5];
				return false;
			}				
		}
		elseif($src_type == 2) { // jpg
			// stt variabel som kommer ihg filtyp
			$this->src_type = "jpg";
			// ls in bilddata till variabeln $im
		   if(!$this->im = @ImageCreateFromJPEG ($this->imagePath)) {
				// stt felbesked
				$this->lastError = $this->text[3];
				// returnera false
				return false;
			}
		}
		elseif($src_type == 3) { // png
			// stt variabel som kommer ihg filtyp
			$this->src_type = "png";
			// ls in bilddata till variabeln $im
		   if(!$this->im = @ImageCreateFromPNG ($this->imagePath)) {
				// stt felbesked
				$this->lastError = $this->text[3];
				// returnera false
				return false;
			}
		}
		else { // unsupported
			// stt felbesked
			$this->lastError = $this->text[2];
			return false;
		}
		// kommer vi hit s har vi hittat en giltig filtyp och satt variabler
//		$this->isResized = false;
		return true;
	}
	
	// (klar) funktionen skalar om bilden till de vrden som finns i variblerna $ny_width...
	protected function resizeImage() {
	
		// om vi inte kunde skapa en ny, tom bild
		if(!$image_p = @imagecreatetruecolor($this->ny_width, $this->ny_height)) {

			// stt felmeddelande
			$this->lastError = $this->text[6];
			
			// returnera false
			return false;
		}
		// vi kunde skapa en ny, tom bild - g vidare
		else {

			if ($this->quality != "low")
				$result = @imagecopyresampled($image_p, $this->im, 0, 0, 0, 0, $this->ny_width, $this->ny_height, $this->src_width, $this->src_height);
			else
				$result = @imagecopyresized($image_p, $this->im, 0, 0, 0, 0, $this->ny_width, $this->ny_height, $this->src_width, $this->src_height);

			// om vi inte kunde kopiera bilddata frn kllbilden
			if(!isset($result) or $result == NULL) {

				// stt felmeddelande
				$this->lastError = $this->text[7];
	
				// frstr bildcontainer
				unset($image_p);			
				
				// returnera false
				return false;
			}
			// annars fortstter vi med bilddata kopierat till $result
			else {
				// stt bilddata. Innehller en rbild
				$this->im = $image_p;

				// frstr bildcontainer
				unset($image_p);			
	
				// returnera true
				return true;
			}
		}
	}

	// (klar) funktionen r en wrapper fr att inte tkomst ska tilltas direkt till funktionen som resizear (calculateImageData)
	public function setSize($thumb = false, $speedresize = false) {
		// full-size - ndra ven quality till hg
		if(!$thumb)	{
			
			// ndra kvalitet till hg
			$this->quality = "high";
	//		die(			$this->quality );
			// nedan stts automatisk utrkning av nya sidor
			$result = $this->calculateImageData(($speedresize?$this->prefs["big_size"]*1.5:$this->prefs["big_size"]));
		}
		// thumbnail
		else
			$result = $this->calculateImageData($this->prefs["small_size"]);
		// r nya storlekar utrknade s resizea bilden
		if($result)
			return $this->resizeImage();
		// returnera false eftersom inte nya storlekar kunde rknas ut
		else 
			return false;
	}
	
	// (klar) den hr funktionen rknar om storlekarna utifrn satta storlekar i instllningarna. Skalar dock inte om
	protected function calculateImageData($size = NULL, $width = NULL, $height = NULL) {

		// r inte ngon storlek satt s stt default till vad som anges i instllningarna. Detta r normalt frfarande
		if(
			(is_null($size) or $size == 0) && 
			(is_null($width) or $width== 0) && 
			(is_null($height) or $height == 0)
		)
			$size = $this->prefs["big_size"];
		// fit image
		if(!(is_null($size)||$size == 0) && ($this->src_width > $size or $this->src_height > $size)) {
			$this->ny_width = (int) ($this->src_width >= $this->src_height?$size: round($size*$this->src_width/$this->src_height, 0));
			$this->ny_height = (int) ($this->src_height >= $this->src_width?$size: round($size*$this->src_height/$this->src_width,0));
		}
		// dimensionera efter bredd
		elseif(!is_null($width) && (is_null($height)||$height == 0)) {
			$this->ny_width = (int) $width;
			$this->ny_height = (int) round($width*$this->src_height/$this->src_width, 0); // INT !!!!
		}
		// dimensionera efter h&ouml;jd
		elseif(!is_null($height) && (is_null($width)||$width == 0)) {
			$this->ny_width = (int) round($height*$this->src_width/$this->src_height, 0); // INT!!!
			$this->ny_height = (int) $height;
		}
		// skala om den till ny storlek
		elseif(!is_null($width) &! is_null($height)) {
			$this->ny_width = (int) $width;
			$this->ny_height = (int) $height;
		}
		
		// annars orginal
		else {
			$this->ny_width = (int) $this->src_width;
			$this->ny_height = (int) $this->src_height;
		}
		
		// terg till originalstorlek ifall det har skalats upp ver
		if($this->ny_width>$this->src_width||$this->ny_height>$this->src_height) {
			$this->ny_width = (int) $this->src_width;
			$this->ny_height = (int) $this->src_height;
		}
		
		## avgrr ny dimensioner
		
		return true;
	}

	// (klar) funktionen returnerar antingen optimerad (jpg/gif/png) bild eller true beroende p om dest_filename r satt (=spara om filen), och vid fel false
	public function optimizeImage($type = NULL, $dest_filename = NULL) {

		// stt bildformat
		if(is_null($type)) 	// om typ inte r satt
			$this->ny_type = $this->src_type; // stt den till ursprungstypen
		else $this->ny_type = $type;
				
		//  returnera en bild av typen...
		// png
		if($this->ny_type == "png") {
			// om bilden bara ska returneras
			if(is_null($dest_filename)) {
				// om det inte gick returnera png
				if(!@imagepng($this->im)) {
					// felbesked
					$this->lastError = $this->text[9] . " png. " . $this->text[11];
					// avbryt
					return false;
				}
			}
			// om bilden ska sparas om
			else {
				// om det inte gick att spara om png
				if(!@imagepng($this->im, $this->prefs["base_path"] . "/" . $this->prefs["pic_path"] . "/" . $dest_filename)) {
					// felbesked
					$this->lastError = $this->text[9] . " png. " . $this->text[11];
					// avbryt
					return false;
				}
			}
			return true;
		}
		## png
		// gif
		elseif($this->ny_type == "gif") { 
			if (function_exists("imagegif")) {
				// om bilden bara ska returneras
				if(is_null($dest_filename)) {
					// om det inte gick returnera gif
					if(!@imagegif($this->im)){ 
						// felbesked
						$this->lastError = $this->text[9] . " gif. " . $this->text[11];
						// avbryt
						return false;
					}
				}
				// om bilden ska sparas om
				else {	
					// om det inte gick att spara om gif
					if(!@imagegif($this->im, $this->prefs["base_path"] . "/" . $this->prefs["pic_path"] . "/" . $dest_filename)) {
						// felbesked
						$this->lastError = $this->text[10] . " gif. " . $this->text[11];
						// avbryt
						return false;
					}
				}
				// har vi kommit hit har bild skapats
				return true;
			}
			else // no gif support
			{
				// felmeddelande
				$this->lastError = $this->text[5];
				
				// avbryt
				return false;
			}				
		}
		## gif
		// jpg
		elseif($this->ny_type == "jpg") { 
			if(is_null($dest_filename)) {
				// om det inte gick att jpeg:a
				if(!imagejpeg($this->im, $dest_filename, 85)) {
					// felbesked
					$this->lastError = $this->text[9] . " jpg. " . $this->text[11];
					// avbryt
					return false;
				}
			}			
			else {
				if(!imagejpeg($this->im, $this->prefs["base_path"] . "/" . $this->prefs["pic_path"] . "/" . $dest_filename, 95)) { //  spara om den och returnera true/false 
					// felbesked
					$this->lastError = $this->text[10] . " jpg. " . $this->text[11];
					// avbryt
					return false;
				}
				else {
					// eftersom bilden har ftt en ny storlek mste denna ven reflekteras i src_width etc
					$this->src_width = $this->ny_width;
					$this->src_height = $this->ny_height;
				}
			}
			// jpg eller spara som som jpg gick bra
			return true;
		}
		## jpg
		// error - output stdjs inte
		else {
			// stt felmeddelande
			$this->lastError = $this->text[8];
			
			// avbryt
			return false;
		## error - output stdjs inte
		}
	}
	
	// (klar) funktionen returnerar en header. r inte type satt s returneras senast satta imagetyp. Efter att den kallas r det krt ;)
	public function returnHeader($type = NULL) {
		if (is_null($type))
			$type = $this->ny_type;
		if($type = "jpg")
			header('Content-type: image/jpeg');
		elseif($type = "png")
			header('Content-type: image/png');
		elseif($type = "gif")
			header('Content-type: image/gif');
		
		else { // unsupported output-typ
			// felmeddelande
			$this->lastError = $this->text[8];
				
			// avbryt
			return false;
		}
	// vi har kommit s hr lngt - returnera true
	return true;
	}

	// funktion som unloadar resources
	protected function __destruct() {
		unset($prefs, $lastError, $imagePath, $im, $quality, $src_width, $src_height, $src_type, $ny_width, $ny_height, $ny_type, $text);
	}
}

?>